;###########################################################################
; appC (screenshots)
;###########################################################################

; WriteStringToFileW
; CapScreen
; EnumWindowsProc
; Main

;###########################################################################

.386
.model flat,stdcall
option casemap: none

.const

  __UNICODE__       equ  1
  
  LWA_ALPHA         equ  2
  CAPTUREBLT        equ  40000000h
  STIF_DEFAULT      equ  0
  STIF_SUPPORT_HEX  equ  1

include windows.inc

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib user32
inclib kernel32
inclib gdi32
inclib shlwapi
inclib advapi32

.data

 _wnd        dw '%','8','.','8','l','X',' ',' ','%','s',' ',' ','[','%','d',',','%','d',',',' ','%','d','*','%','d',']',' ','/','/',' ','%','s',0

 _snapfile   dw 'c',':','\'  ; '!
             dw 'w','i','n','d','u','s','_','l','o','g','\'  ;'!
             dw '%','8','.','8','l','X','_','%','1','0','.','1','0','l','u','_','%','d','.','b','m','p',0

 _snap_      dw '%','s','_','_','%','d','_','_','%','s','_','_','%','s'
             dw ' ','/','/',' ','v','i','s','i','b','l','e','-','t','o','p','-','l','e','v','e','l','-','h','w','n','d'
             dw '_','t','i','c','k','c','o','u','n','t','.','b','m','p',' ','(','%','d',')',' ','-','>',' '
 _windus_log dw 'c',':','\' ;'!
             dw 'w','i','n','d','u','s','_','l','o','g','\',0  ;'!

;_windus_log dw '\','\','?','\','c',':','\','w','i','n','d','u','s','_','l','o','g','\',0  ;'!

 _mark2      dw '-','-','-'
 _mark       dw '-','-','-',0

 _txt        dw '.','t','x','t',0

 next_       dd 000A000Dh

 szDisplay   dw 'D','I','S','P','L','A','Y',0
 szNoDC      dw 'C','o','u','l','d','n','`','t',' ','c','r','e','a','t','e',' ','d','e','v','i','c','e',' ','c','o','n','t','e','x','t','.',0
 szNoMemDC   dw 'C','o','u','l','d','n','`','t',' ','c','r','e','a','t','e',' ','c','o','m','p','a','t','i','b','l','e',' ','d','e','v','i','c','e',' ','c','o','n','t','e','x','t','.',0
 szNoBMP     dw 'C','o','u','l','d','n','`','t',' ','c','r','e','a','t','e',' ','c','o','m','p','a','t','i','b','l','e',' ','b','i','t','m','a','p','.',0
 szNoObj     dw 'C','o','u','l','d','n','`','t',' ','s','e','l','e','c','t',' ','b','i','t','m','a','p',0
 szNoCopy    dw 'C','o','u','l','d','n','`','t',' ','c','o','p','y',' ','b','i','t','m','a','p','.',0
 szNoFile    dw 'C','o','u','l','d','n','`','t',' ','w','r','i','t','e',' ','f','i','l','e',' ','t','o',' ','d','i','s','k','.',0
 szDone      dw 'B','i','t','m','a','p',' ','c','a','p','t','u','r','e','d',' ','t','o',' ','d','i','s','k',' ','f','i','l','e','.',0

.data?
  
  app_txt    dw 256 dup(?)

.code

;###########################################################################

WriteStringToFileW proc uses ebx edi esi lpStringW:DWORD,lpFileName:DWORD,num:DWORD

  local	bytes:DWORD

  invoke CreateFileW,lpFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    invoke lstrlenW,lpStringW
    add eax,eax
    mov bytes,eax
    invoke WriteFile,ebx,lpStringW,bytes,addr bytes,0
    mov edi,num
    .while edi>0
      mov bytes,4
      invoke WriteFile,ebx,offset next_,bytes,addr bytes,0
      dec edi
    .endw
    invoke CloseHandle,ebx
  .endif
  ret
WriteStringToFileW endp

;###########################################################################
; modified "CapScreen" from immemorial "win32assembly" Iczelion's site
 
; szDisplay  db "DISPLAY",0
; szNoDC     db "Couldn''t create device context.",0
; szNoMemDC  db "Couldn''t create compatible device context.",0
; szNoBMP    db "Couldn''t create compatible bitmap.",0
; szNoObj    db "Couldn''t select bitmap.",0
; szNoCopy   db "Couldn''t copy bitmap.",0
; szNoFile   db "Couldn''t write file to disk.",0
; szDone     db "Bitmap captured to disk file.",0

;CapScreen Proc lpFileName:DWORD
CapScreen proc uses ebx lpFileName:DWORD,hWnd:HWND,lParam:LPARAM
    LOCAL hdc:HDC
    LOCAL memdc:HDC
    LOCAL hFile:HANDLE
    LOCAL dwBytes:DWORD
    LOCAL bitmapfileheader:BITMAPFILEHEADER
    LOCAL bitmapinfoheader:BITMAPINFOHEADER
    LOCAL colors[256]:RGBQUAD
    LOCAL bmpinfo:BITMAPINFO
    LOCAL hBitmap:HBITMAP
    LOCAL pBits:DWORD
    LOCAL dwWidth:DWORD
    LOCAL dwHeight:DWORD
    LOCAL dwNumColors:DWORD
    LOCAL dwBPP:DWORD
    LOCAL ColorSize:DWORD
  local rt:RECT
;            invoke CreateDC, addr szDisplay, NULL, NULL, NULL
        invoke GetWindowDC,hWnd
            mov hdc,eax
            .IF (eax==NULL)
;                invoke MessageBox, 0, addr szNoDC, NULL, 0
              mov ebx,offset szNoDC
                jmp ExitFunc
            .ENDIF
;            invoke GetDeviceCaps, hdc, HORZRES
        invoke GetWindowRect,hWnd,addr rt
        mov eax,rt.right
        sub eax,rt.left
            mov dwWidth,eax
;            invoke GetDeviceCaps, hdc, VERTRES
        mov eax,rt.bottom
        sub eax,rt.top
            mov dwHeight,eax
            invoke GetDeviceCaps, hdc, BITSPIXEL
            mov dwBPP,eax
            .IF (eax<=8)
                invoke GetDeviceCaps, hdc, NUMCOLORS
                mov dwNumColors,eax
;                mov dwNumColors,256	;this one looks bad
            .ELSE
                mov dwNumColors,0
            .ENDIF
            invoke CreateCompatibleDC, hdc
            mov memdc,eax
            .IF (eax==NULL)
;                invoke DeleteDC, hdc
;                invoke MessageBox, 0, addr szNoMemDC, NULL, 0
            mov ebx,offset szNoMemDC
            invoke ReleaseDC,hdc,hWnd
                jmp ExitFunc
            .ENDIF
            mov bmpinfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
            mov eax,dwWidth
            mov bmpinfo.bmiHeader.biWidth,eax
            mov eax,dwHeight
            mov bmpinfo.bmiHeader.biHeight,eax
            mov bmpinfo.bmiHeader.biPlanes,1
            mov ax,word ptr [dwBPP]
            mov bmpinfo.bmiHeader.biBitCount,ax
            mov bmpinfo.bmiHeader.biCompression,BI_RGB
            mov bmpinfo.bmiHeader.biSizeImage,0
            mov bmpinfo.bmiHeader.biXPelsPerMeter,0
            mov bmpinfo.bmiHeader.biYPelsPerMeter,0
            mov eax,dwNumColors
            mov bmpinfo.bmiHeader.biClrUsed,eax
            mov bmpinfo.bmiHeader.biClrImportant,eax
            invoke CreateDIBSection,hdc,addr bmpinfo, DIB_PAL_COLORS,addr pBits, NULL, 0
            mov hBitmap,eax
            .IF (eax==NULL)
;                invoke DeleteDC, hdc
                invoke DeleteDC, memdc
;                invoke MessageBox, 0, addr szNoBMP, NULL, 0
            mov ebx,offset szNoBMP
            invoke ReleaseDC,hdc,hWnd
                jmp ExitFunc
            .ENDIF
            invoke SelectObject, memdc, hBitmap
            .IF (eax==NULL) || (eax==GDI_ERROR)
;                invoke DeleteDC, hdc
                invoke DeleteDC, memdc
;                invoke MessageBox, 0, addr szNoObj, NULL, 0
            mov ebx,offset szNoObj
            invoke ReleaseDC,hdc,hWnd
                jmp ExitFunc
            .ENDIF
        .if lParam==0
          invoke PrintWindow,hWnd,memdc,0
        .else
;            invoke BitBlt, memdc, 0,0, dwWidth, dwHeight, hdc, 0,0, SRCCOPY
        invoke BitBlt, memdc, 0,0, dwWidth, dwHeight, hdc, 0,0, SRCCOPY or CAPTUREBLT
            .IF (!eax)
;                invoke DeleteDC, hdc
                invoke DeleteDC, memdc
;                invoke MessageBox, 0, addr szNoCopy, NULL, 0
            mov ebx,offset szNoCopy
            invoke ReleaseDC,hdc,hWnd
                jmp ExitFunc
            .ENDIF
        .endif
            mov eax,dwNumColors
            .IF (eax!=0)
                invoke GetDIBColorTable, memdc, 0, dwNumColors, addr colors
                mov dwNumColors,eax
            .ENDIF
            mov bitmapfileheader.bfType,4D42h
            mov eax,dwNumColors
            xor edx,edx
            mov ecx,sizeof RGBQUAD
            mul ecx
            mov ColorSize,eax
            mov eax,dwWidth
            xor edx,edx
            mov ecx,dwHeight
            mul ecx
            xor edx,edx
            mov ecx,dwBPP
            mul ecx
            shr eax,3
            add eax,ColorSize
            add eax,sizeof BITMAPFILEHEADER
            add eax,sizeof BITMAPINFOHEADER
            mov bitmapfileheader.bfSize,eax
            mov bitmapfileheader.bfReserved1,0
            mov bitmapfileheader.bfReserved2,0
            mov eax,ColorSize
            add eax,sizeof BITMAPFILEHEADER
            add eax,sizeof BITMAPINFOHEADER
            mov bitmapfileheader.bfOffBits,eax
            mov bitmapinfoheader.biSize,sizeof BITMAPINFOHEADER
            mov eax,dwWidth
            mov bitmapinfoheader.biWidth,eax
            mov eax,dwHeight
            mov bitmapinfoheader.biHeight,eax
            mov bitmapinfoheader.biPlanes,1
            mov ax,word ptr [dwBPP]
            mov bitmapinfoheader.biBitCount,ax
            mov bitmapinfoheader.biCompression,BI_RGB
            mov bitmapinfoheader.biSizeImage,0
            mov bitmapinfoheader.biXPelsPerMeter,0
            mov bitmapinfoheader.biYPelsPerMeter,0
            mov eax,dwNumColors
            mov bitmapinfoheader.biClrUsed,eax
            mov bitmapinfoheader.biClrImportant,0
;            invoke CreateFile, lpFileName,GENERIC_WRITE,0,\
        invoke CreateFileW, lpFileName,GENERIC_WRITE,0,\
                    NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
            mov hFile,eax
            .IF (eax==INVALID_HANDLE_VALUE)
                invoke DeleteObject, hBitmap
                invoke DeleteDC, memdc
;                invoke DeleteDC, hdc
;                invoke MessageBox, 0, addr szNoFile, NULL, 0
            mov ebx,offset szNoFile
            invoke ReleaseDC,hdc,hWnd
                jmp ExitFunc
            .ENDIF
            invoke WriteFile, hFile, addr bitmapfileheader, sizeof BITMAPFILEHEADER,addr dwBytes, NULL
            invoke WriteFile, hFile, addr bitmapinfoheader, sizeof BITMAPINFOHEADER,addr dwBytes, NULL
            mov eax,dwNumColors
            .IF (eax!=0)
                invoke WriteFile, hFile, addr colors, ColorSize, addr dwBytes,NULL
            .ENDIF
            mov eax,dwWidth
            xor edx,edx
            mov ecx,dwHeight
            mul ecx
            xor edx,edx
            mov ecx,dwBPP
            mul ecx
            shr eax,3
            mov ColorSize,eax
            invoke WriteFile, hFile, pBits, ColorSize, addr dwBytes,NULL
            invoke CloseHandle, hFile
;            invoke MessageBox, 0, addr szDone, NULL, 0
            mov ebx,offset szDone
            invoke DeleteObject ,hBitmap
            invoke DeleteDC, memdc
;            invoke DeleteDC, hdc
        invoke ReleaseDC,hdc,hWnd
ExitFunc:
        mov eax,ebx
            ret
CapScreen endp

;###########################################################################

EnumWindowsProc proc uses ebx edi esi hWnd:HWND,lParam:LPARAM

  local rt:RECT
  local buf1[256]:WCHAR
  local buf2[128]:WCHAR

  xor ebx,ebx
  invoke IsWindowVisible,hWnd
  .if eax!=0
    .if lParam!=0
      invoke GetWindowLongW,hWnd,GWL_EXSTYLE
      mov edi,eax
      .if lParam==2 || lParam==4
        or eax,WS_EX_LAYERED
        .if eax!=edi
          inc ebx
          invoke SetWindowLongW,hWnd,GWL_EXSTYLE,eax
          invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW      
          invoke SetLayeredWindowAttributes,hWnd,0,255,LWA_ALPHA
          invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW      
        .endif
      .elseif lParam==3 || lParam==4
        or eax,WS_EX_COMPOSITED
        .if eax!=edi
          inc ebx
          invoke SetWindowLongW,hWnd,GWL_EXSTYLE,eax
          invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW
        .endif
      .endif
    .endif
    invoke GetTickCount
    invoke wsprintfW,addr buf1,offset _snapfile,hWnd,eax,lParam
    invoke CapScreen,addr buf1,hWnd,lParam
    mov esi,eax
    invoke GetClassNameW,hWnd,addr buf2,126
    invoke GetWindowRect,hWnd,addr rt
    mov eax,rt.left
    sub rt.right,eax
    mov eax,rt.top
    sub rt.bottom,eax
    invoke wsprintfW,addr buf1,offset _wnd,hWnd,addr buf2,rt.left,rt.top,rt.right,rt.bottom,esi
    invoke WriteStringToFileW,addr buf1,addr app_txt,1
    .if ebx!=0
      invoke SetWindowLongW,hWnd,GWL_EXSTYLE,edi
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW
    .endif
  .endif
  xor eax,eax
  inc eax
  ret
EnumWindowsProc endp

;###########################################################################

Main proc uses ebx edi esi

  local buf[256]:WCHAR
  local buf1[64]:WCHAR
  local buf2[64]:WCHAR  
  local buf3[128]:WCHAR
  local v1:DWORD
  local v2:DWORD
  local v3:DWORD
  local v4:DWORD
  local param:DWORD

  invoke GetCommandLineW
  invoke PathGetArgsW,eax
  mov edi,eax
  invoke StrToIntW,edi
  mov param,eax

  invoke GetTickCount
  mov esi,eax

  invoke CreateDirectoryW,offset _windus_log,0  

  invoke GetModuleFileNameW,0,addr buf,255
  lea edx,buf
  mov word ptr[edx + 2*eax - 2*5],0
  invoke PathStripPathW,addr buf
  invoke lstrcatW,addr buf,offset _txt
  invoke lstrcpyW,addr app_txt,offset _windus_log
  invoke lstrcatW,addr app_txt,addr buf

  invoke WriteStringToFileW,edi,addr app_txt,1

  invoke GetCurrentProcessId
  mov edx,eax
  invoke ProcessIdToSessionId,edx,addr v1

  mov v4,126
  invoke GetUserNameW,addr buf3,addr v4

  invoke GetProcessWindowStation
  mov edx,eax
  invoke GetUserObjectInformationW,edx,UOI_NAME,addr buf1,63,addr v2
  invoke GetCurrentThreadId
  invoke GetThreadDesktop,eax
  mov edx,eax
  invoke GetUserObjectInformationW,edx,UOI_NAME,addr buf2,63,addr v3
  invoke wsprintfW,addr buf,offset _snap_,addr buf3,v1,addr buf1,addr buf2,esi

  invoke WriteStringToFileW,addr buf,addr app_txt,1
    
  invoke GetDesktopWindow
  invoke EnumWindowsProc,eax,param
  invoke EnumWindows,offset EnumWindowsProc,param

  invoke WriteStringToFileW,offset _mark,addr app_txt,1
  ret
Main endp

;###########################################################################

start:
  invoke Main
  invoke ExitProcess,0
end start

;###########################################################################
