;###########################################################################
; appB
;###########################################################################

; WriteStringToFileW
; EnumDesktopProcW
; EnumWindowStationProcW
;; PrintSysMetrics
; Main

;###########################################################################


.386
.model flat,stdcall
option casemap: none

.const

  __UNICODE__  equ  1
  
  WINSTA_ENUMDESKTOPS       equ      0001h
  WINSTA_READATTRIBUTES     equ      0002h
  WINSTA_ACCESSCLIPBOARD    equ      0004h
  WINSTA_CREATEDESKTOP      equ      0008h
  WINSTA_WRITEATTRIBUTES    equ      0010h
  WINSTA_ACCESSGLOBALATOMS  equ      0020h
  WINSTA_EXITWINDOWS        equ      0040h ; 0080h ?
  WINSTA_ENUMERATE          equ      0100h
  WINSTA_READSCREEN         equ      0200h
  WINSTA_ALL_ACCESS         equ      037Fh ; sum
  MAXIMUM_ALLOWED           equ  02000000h


include windows.inc

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib user32
inclib kernel32
inclib advapi32
inclib shlwapi

.data

 _wnd_head   dw ' ',' ',' ',' ','p','i','d',' ',' ','<','p','p','i','d','>',' ',' ',' ','t','i','d',' ',' ',' '
             dw '[','x',',','y',',',' ','w','i','d','t','h','*','h','e','i','g','h','t',']',' ',' ',' ',' ',' ',' ',' ',' ',' ','.',' ',' '
             dw 'w','s','_',' ',' ',' ',' ',' ',' ',' ','w','s','_','e','x','_',' ',' ',' ',' ','c','s','_',' ',' ',' ',' ',' ',' ',' ','w','n','d','x'
             dw ' ',' ','<','p','r','e','v','w','n','d','>',' ',' ','<','o','w','n','e','r','>',' ',' ',' ',' ','<','p','a','r','e','n','t','>',' ',' ',' '
             dw 'w','i','n','d','o','w',' ',' ',' ',' ',' ',' ','"','c','l','a','s','s','"',' ','-','-','-',' ','"','t','e','x','t','"',' ','-','-','-',' ','"','e','x','e','"',0

 _default    dw 'D','e','f','a','u','l','t',0
 _txt        dw '.','t','x','t',0
 _mark       dw '-','-','-',0
 _sp         dw ' ',0
 _z          dw 0

 _param      dw ' ','%','d',0

 _swd        dw '%','s','\'  ;'!
             dw '%','d','\'  ;'!
 _wd         dw '%','s','\'  ;'!
             dw '%','s','%','s',0

 _windus_log dw 'c',':','\'  ;'!
             dw 'w','i','n','d','u','s','_','l','o','g','\',0  ;'!

;_ns         dw '%','s','\'  ;'!
;            dw '%','d','\'  ;'!
;            dw 0

 next_       dd 000A000Dh
  
.data?

 param       dd ?
 sessid      dd ?
 toggle      dd ?
 curdir      dw 256 dup(?)
 app_a_exe   dw 256 dup(?)
 app_txt     dw 256 dup(?)

.code

;###########################################################################

WriteStringToFileW proc uses ebx edi esi lpStringW:DWORD,lpFileName:DWORD,num:DWORD

  local	bytes:DWORD

  invoke CreateFileW,lpFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    invoke lstrlenW,lpStringW
    add eax,eax
    mov bytes,eax
    invoke WriteFile,ebx,lpStringW,bytes,addr bytes,0
    mov edi,num
    .while edi>0
      mov bytes,4
      invoke WriteFile,ebx,offset next_,bytes,addr bytes,0
      dec edi
    .endw
    invoke CloseHandle,ebx
  .endif
  ret
WriteStringToFileW endp

;###########################################################################

EnumDesktopProcW proc uses ebx edi esi lpszDesktop:LPWSTR,lParam:LPARAM  ; lpszWindowStation

  local pi:PROCESS_INFORMATION
  local sis:STARTUPINFOW
  local buf[256]:WCHAR
  local buf2[256]:WCHAR
  local v1:DWORD

  mov eax,param
  and eax,4h
  .if eax!=0
    mov v1,255
    invoke GetUserNameW,addr buf2,addr v1
  .else
    mov word ptr[buf2],0
  .endif

  .if toggle==0
    invoke wsprintfW,addr buf,offset _swd,addr buf2,sessid,lParam,lpszDesktop,offset _sp
    invoke WriteStringToFileW,addr buf,addr app_txt,1
  .else ; toggle!=0
    invoke RtlZeroMemory,addr sis,sizeof sis
    mov sis.cb,sizeof sis
    invoke wsprintfW,addr buf,offset _wd,lParam,lpszDesktop,offset _z
    lea eax,buf
    mov sis.lpDesktop,eax
    mov sis.dwFlags,STARTF_USESHOWWINDOW
    mov sis.wShowWindow,SW_SHOWNORMAL
    mov edx,CREATE_DEFAULT_ERROR_MODE  ;  CREATE_SUSPENDED
    invoke CreateProcessW,0,addr app_a_exe,NULL,NULL,FALSE,edx,NULL,addr curdir,addr sis,addr pi
    invoke WaitForSingleObject,pi.hProcess,INFINITE
    invoke CloseHandle,pi.hThread
    invoke CloseHandle,pi.hProcess
  .endif
  mov eax,TRUE
  ret
EnumDesktopProcW endp

;###########################################################################

EnumWindowStationProcW proc uses ebx edi esi lpszWindowStation:LPWSTR,lParam:LPARAM

  local buf[256]:WCHAR
  local buf2[256]:WCHAR
  local v1:DWORD

  mov eax,param
  and eax,4h
  .if eax!=0
    mov v1,255
    invoke GetUserNameW,addr buf2,addr v1
  .else
    mov word ptr[buf2],0
  .endif

  invoke OpenWindowStationW,lpszWindowStation,FALSE,MAXIMUM_ALLOWED
  mov ebx,eax
  invoke EnumDesktopsW,ebx,offset EnumDesktopProcW,lpszWindowStation
  .if eax==0
    .if toggle==0
      invoke wsprintfW,addr buf,offset _swd,addr buf2,sessid,lpszWindowStation,offset _default,offset _sp
      invoke WriteStringToFileW,addr buf,addr app_txt,1
    .endif
  .endif
  invoke CloseWindowStation,ebx
  mov eax,TRUE
  ret
EnumWindowStationProcW endp

;###########################################################################

;.data
; _ft             dw '%','2','8','.','d','*','%','d',' ',' ','%','s',0
; _ft_spi         dw '%','2','0','.','d',',','%','d',',',' ','%','d','*','%','d',' ',' ','%','s',0
; _spi_workarea   dw 's','p','i','_','w','o','r','k','a','r','e','a',0
; _fullscreen     dw 's','m','_','f','u','l','l','s','c','r','e','e','n',0
; _screen         dw 's','m','_','s','c','r','e','e','n',0
; _maximized      dw 's','m','_','m','a','x','i','m','i','z','e','d',0
; _maxtrack       dw 's','m','_','m','a','x','t','r','a','c','k',0
; _virtualscreen  dw 's','m','_','v','i','r','t','u','a','l','s','c','r','e','e','n',0
;.code
;
;PrintSysMetrics proc uses ebx edi esi lpFileName:DWORD
;
;  local buf[256]:WCHAR
;  local rt:RECT
;
;  push 0
;  push offset _virtualscreen
;  push SM_CXVIRTUALSCREEN
;  push SM_CYVIRTUALSCREEN
;  push offset _screen
;  push SM_CXSCREEN
;  push SM_CYSCREEN
;  push offset _fullscreen
;  push SM_CXFULLSCREEN
;  push SM_CYFULLSCREEN
;  push offset _maximized
;  push SM_CXMAXIMIZED
;  push SM_CYMAXIMIZED
;  push offset _maxtrack
;  push SM_CXMAXTRACK
;  push SM_CYMAXTRACK
;  .while TRUE
;    pop eax
;  .break .if eax==0
;    invoke GetSystemMetrics,eax
;    mov ebx,eax
;    pop eax
;    invoke GetSystemMetrics,eax
;    pop edx
;    invoke wsprintfW,addr buf,offset _ft,eax,ebx,edx
;    invoke WriteStringToFileW,addr buf,lpFileName,1
;  .endw
;  invoke SystemParametersInfo,SPI_GETWORKAREA,0,addr rt,0
;  mov ecx,rt.right
;  sub ecx,rt.left
;  mov edx,rt.bottom
;  sub edx,rt.top
;  invoke wsprintfW,addr buf,offset _ft_spi,rt.left,rt.top,ecx,edx,offset _spi_workarea
;  invoke WriteStringToFileW,addr buf,lpFileName,2
;;  invoke WriteStringToFileW,offset _sp,lpFileName,1
;  ret
;PrintSysMetrics endp

;###########################################################################

Main proc uses ebx edi esi

  local buf[256]:WCHAR
  local buf1[64]:WCHAR
; local buf2[256]:WCHAR
; local v1:DWORD

  invoke GetCommandLineW
  invoke PathGetArgsW,eax
  invoke StrToIntW,eax
  mov param,eax

  invoke GetModuleFileNameW,0,addr buf,255
  mov edi,eax

  invoke lstrcpyW,addr app_a_exe,addr buf
  lea edx,app_a_exe
  mov word ptr[edx + 2*edi - 2*5],'a'
  lea edx,buf
  mov word ptr[edx + 2*edi - 2*5],0

  invoke lstrcpyW,addr curdir,addr buf
  invoke PathRemoveFileSpecW,addr curdir
  invoke PathAddBackslashW,addr curdir

  invoke lstrcpyW,addr app_txt,offset _windus_log

  invoke PathStripPathW,addr buf
  invoke lstrcatW,addr buf,offset _txt
  invoke lstrcatW,addr app_txt,addr buf

  .if param!=0
    invoke wsprintfW,addr buf1,offset _param,param
    invoke lstrcatW,addr app_a_exe,addr buf1
  .endif

  invoke GetCurrentProcessId
  mov edx,eax
  invoke ProcessIdToSessionId,edx,addr sessid

; mov eax,param
; and eax,4h
; .if eax!=0
;   mov v1,255
;   invoke GetUserNameW,addr buf2,addr v1
; .else
;   mov word ptr[buf2],0
; .endif
; invoke wsprintfW,addr buf,offset _ns,addr buf2,sessid
; invoke WriteStringToFileW,addr buf,addr app_txt,1
; invoke PrintSysMetrics,addr app_txt

  invoke WriteStringToFileW,offset _wnd_head,addr app_txt,2

  invoke EnumWindowStationsW,offset EnumWindowStationProcW,0
  invoke WriteStringToFileW,offset _mark,addr app_txt,2
  inc toggle
  invoke EnumWindowStationsW,offset EnumWindowStationProcW,0
  ret
Main endp

;###########################################################################

start:
  invoke Main
  invoke ExitProcess,0
end start

;###########################################################################
