;###########################################################################
; appA ; enum all/top-level windows
;###########################################################################

; ProcessNameFromPidW
; WriteStringToFileW
; WriteEnumIsWindowToFileW_
; Main

;###########################################################################

.386
.model flat,stdcall
option casemap: none

.const
  __UNICODE__  equ  1

include windows.inc

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib user32
inclib kernel32
inclib advapi32
inclib shlwapi

.data

 _wnd_head   dw ' ',' ',' ',' ','p','i','d',' ',' ','<','p','p','i','d','>',' ',' ',' ','t','i','d',' ',' ',' '
             dw '[','x',',','y',',',' ','w','i','d','t','h','*','h','e','i','g','h','t',']',' ',' ',' ',' ',' ',' ',' ',' ',' ','.',' ',' '
             dw 'w','s','_',' ',' ',' ',' ',' ',' ',' ','w','s','_','e','x','_',' ',' ',' ',' ','c','s','_',' ',' ',' ',' ',' ',' ',' ','w','n','d','x'
             dw ' ',' ','<','p','r','e','v','w','n','d','>',' ',' ','<','o','w','n','e','r','>',' ',' ',' ',' ','<','p','a','r','e','n','t','>',' ',' ',' '
             dw 'w','i','n','d','o','w',' ',' ',' ',' ',' ',' ','"','c','l','a','s','s','"',' ','-','-','-',' ','"','t','e','x','t','"',' ','-','-','-',' ','"','e','x','e','"',0

 _wnd        dw '%','s','%','6','.','4','d','%','7','.','4','d','%','7','.','4','d'
             dw ' ',' ',' ','%','s',' ','%','8','.','8','l','X',' ',' ','%','8','.','8','l','X',' ',' ','%','8','.','8','l','X',' ',' ','%','4','.','4','l','X'
             dw '%','6','.','4','l','X','.','%','4','.','4','l','X','%','6','.','4','l','X','.','%','4','.','4','l','X','%','6','.','4','l','X','.','%','4','.','4','l','X'
             dw '%','6','.','4','l','X','.','%','4','.','4','l','X',' ',' ',' ','"','%','s','"', ' ','-','-','-',' ','"','%','s','"',' ','-','-','-',' ','"','%','s','"',0

 _rect       dw '[','%','d',',','%','d',',',' ','%','d','*','%','d',']',0

 _swd        dw '%','s','\'  ;'!
             dw '%','d','\'  ;'!
             dw '%','s',0

 _swd2       dw '%','s','\'  ;'!
             dw '%','d','\'  ;'!
             dw '%','s','\'  ;'!
             dw '%','s',0

 _mark       dw '-','-'
 _notopl     dw '-',0

 _sp         dw ' ',0

 _txt        dw '.','t','x','t',0         

 _windus_log dw 'c',':','\'  ;'!
             dw 'w','i','n','d','u','s','_','l','o','g','\',0  ;'!

 _32769      dw '#','3','2','7','6','9',0
 _z          dw 0

 next_       dd 000A000Dh

.data?

 app_txt     dw 256 dup(?)

.code

;###########################################################################

HwordFromLword proc uses ebx edi esi Lword:DWORD ; hwnd/hmenu ; Lword==0000XXXXh, Hword==XXXX0000h)

  mov ebx,Lword
  xor eax,eax
  xor edx,edx
  .if ebx!=0
    xor edi,edi
    inc edi
    .while edi<=0FFFFh
      mov esi,edi
      shl esi,16
      or esi,ebx
      invoke IsWindow,esi
      .if eax!=0
        mov edx,edi ; Hword
        mov eax,esi ; hwnd
        jmp @f
      .endif
      inc edi
    .endw
  .endif
@@:
  ret
HwordFromLword endp

;###########################################################################

ProcessNameFromPidW proc uses ebx edi esi lpbuf:DWORD,pid:DWORD

  local pe32:PROCESSENTRY32W

  xor edi,edi
  xor esi,esi
  invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,pid
  mov ebx,eax
  invoke RtlZeroMemory,addr pe32,sizeof pe32
  mov pe32.dwSize,sizeof pe32
  invoke Process32FirstW,ebx,addr pe32 
@@:
  test eax,eax
  jz @@@
  mov eax,pid
  cmp pe32.th32ProcessID,eax
  jz @f
  invoke Process32NextW,ebx,addr pe32
  jmp @b
@@:
  mov edi,pe32.th32ParentProcessID
  mov esi,pe32.cntThreads
  invoke lstrcpyW,lpbuf,addr pe32.szExeFile
@@@:
  invoke CloseHandle,ebx
  mov edx,esi ; threads count
  mov eax,edi ; parent pid
  ret
ProcessNameFromPidW endp

;###########################################################################

WriteStringToFileW proc uses ebx edi esi lpStringW:DWORD,lpFileName:DWORD,num:DWORD

  local	bytes:DWORD

  invoke CreateFileW,lpFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    invoke lstrlenW,lpStringW
    add eax,eax
    mov bytes,eax
    invoke WriteFile,ebx,lpStringW,bytes,addr bytes,0
    mov edi,num
    .while edi>0
      mov bytes,4
      invoke WriteFile,ebx,offset next_,bytes,addr bytes,0
      dec edi
    .endw
    invoke CloseHandle,ebx
  .endif
  ret
WriteStringToFileW endp

;###########################################################################
; lParam & 1h !=0 -> top-level_only  ; else: all_windows
;          2h !=0 -> move_to_right
;          4h !=0 -> show_user_name
;          8h !=0 -> mark_caption_of_#32769

WriteEnumIsWindowToFileW_ proc uses ebx edi esi lpFileName:DWORD,lParam:LPARAM 

  local rt:RECT
  local pt:POINT
  local v0:DWORD
  local v1:DWORD
  local v2:DWORD
  local v3:DWORD
  local v4:DWORD
  local v5:DWORD
  local v6:DWORD
  local v7:DWORD
  local v8:DWORD
  local v9:DWORD
  local rght:DWORD
  local ppid:DWORD
  local pid:DWORD
  local tid:DWORD
  local hw:DWORD
  local notoplevel:DWORD
  local buff[1024]:WCHAR
  local buf0[256]:WCHAR  
  local buf1[256]:WCHAR
  local buf2[256]:WCHAR
  local buf3[256]:WCHAR

  invoke GetDesktopWindow
  mov ebx,eax

  invoke GetWindowRect,ebx,addr rt
  mov eax,rt.right
  mov rght,eax

  mov eax,lParam
  and eax,8h
  .if eax!=0
    invoke GetWindowTextW,ebx,addr buf3,255
    .if eax==0
      mov eax,offset _32769
    .else
      mov eax,offset _z
    .endif
    invoke SetWindowTextW,ebx,eax
  .endif

  xor ebx,ebx
  .while ebx<=0FFFFh
    invoke IsWindow,ebx
    .if eax!=0
      invoke HwordFromLword,ebx
      mov hw,eax

      invoke GetAncestor,hw,GA_ROOT  ; (is top-level window)
      .if eax!=0 && eax!=hw
        mov v9,offset _notopl
      .else
        mov v9,offset _sp
      .endif

      mov edx,lParam
      and edx,1h
      .if edx!=0
        .if eax!=0 && eax!=hw
          jmp @f
        .endif

        mov edx,lParam
        and edx,2h
        .if edx!=0

          invoke GetWindowRect,hw,addr rt
          mov edx,rt.right
          mov edi,rght
          .if edx>0 && edx<edi
            sub edi,edx
            add edi,rt.left            
            invoke SetWindowPos,hw,0,edi,rt.top,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_FRAMECHANGED
          .endif
        .endif
      .endif
      
      invoke GetWindowRect,hw,addr rt
      mov eax,rt.left
      sub rt.right,eax
      mov eax,rt.top
      sub rt.bottom,eax
      invoke wsprintfW,addr buf0,offset _rect,rt.left,rt.top,rt.right,rt.bottom
      mov edi,30
      sub edi,eax
      .while edi>0
        invoke lstrcatW,addr buf0,offset _sp
        dec edi
      .endw
      xor eax,eax
      mov pid,eax
      mov v0,eax
      lea edx,buf1
      mov word ptr[edx],ax
      lea edx,buf2
      mov word ptr[edx],ax
      lea edx,buf3
      mov word ptr[edx],ax
      invoke GetClassNameW,hw,addr buf1,255
      invoke SendMessageTimeoutW,hw,WM_GETTEXT,255,addr buf2,SMTO_ABORTIFHUNG,300,addr v0
      lea eax,buf2
      xor edi,edi
      .while edi<255
        mov dx,word ptr[eax+2*edi]
      .break .if dx<20h
        inc edi
      .endw
      mov word ptr[eax+2*edi],0
      invoke GetWindowThreadProcessId,hw,addr pid
      mov tid,eax
      invoke ProcessNameFromPidW,addr buf3,pid
      mov ppid,eax
      invoke GetWindowLongW,hw,GWL_STYLE
      mov v1,eax
      invoke GetWindowLongW,hw,GWL_EXSTYLE
      mov v2,eax
      invoke GetClassLongW,hw,GCL_STYLE
      mov v3,eax
      invoke GetClassLongW,hw,GCL_CBWNDEXTRA
      mov v4,eax
      invoke GetWindow,hw,GW_HWNDPREV
      mov ecx,eax
      and eax,0FFFFh
      mov v6,eax
      shr ecx,16
      mov v5,ecx
      invoke GetWindow,hw,GW_OWNER
      mov ecx,eax
      and eax,0FFFFh
      mov v8,eax
      shr ecx,16
      mov v7,ecx
      invoke GetAncestor,hw,GA_PARENT
      mov esi,eax
      and esi,0FFFFh
      mov edi,eax
      shr edi,16
      mov edx,hw  ; window
      mov ecx,edx
      and edx,0FFFFh
      shr ecx,16
      invoke wsprintfW,addr buff,offset _wnd,v9,pid,ppid,tid,addr buf0,v1,v2,v3,v4,v5,v6,v7,v8,edi,esi,ecx,edx,addr buf1,addr buf2,addr buf3
      invoke WriteStringToFileW,addr buff,lpFileName,1
    .endif
@@:
    inc ebx
  .endw
  invoke WriteStringToFileW,offset _mark,lpFileName,2
  ret
WriteEnumIsWindowToFileW_ endp

;###########################################################################

Main proc uses ebx edi esi

  local sis:STARTUPINFOW
  local pid:DWORD
  local tid:DWORD
  local v1:DWORD
  local v2:DWORD
  local v3:DWORD
  local v4:DWORD
  local buf[256]:WCHAR
  local buf1[64]:WCHAR
  local buf2[64]:WCHAR
  local buf3[128]:WCHAR

  invoke GetCommandLineW
  invoke PathGetArgsW,eax
  invoke StrToIntW,eax
  mov esi,eax

  invoke GetModuleFileNameW,0,addr buf,255
  lea edx,buf
  mov word ptr[edx + 2*eax - 2*5],0
  invoke PathStripPathW,addr buf
  invoke lstrcatW,addr buf,offset _txt
  invoke lstrcpyW,addr app_txt,offset _windus_log
  invoke lstrcatW,addr app_txt,addr buf

  invoke GetCurrentProcessId
  mov edx,eax
  invoke ProcessIdToSessionId,edx,addr v1

  mov eax,esi
  and eax,4h
  .if eax!=0
    mov v4,126
    invoke GetUserNameW,addr buf3,addr v4
  .else
    lea edx,buf3
    mov word ptr[edx],0
  .endif

  invoke RtlZeroMemory,addr sis,sizeof sis
  mov sis.cb,sizeof sis
  invoke GetStartupInfoW,addr sis

  invoke lstrlenW,sis.lpDesktop
  .if eax!=0
    invoke wsprintfW,addr buf,offset _swd,addr buf3,v1,sis.lpDesktop
  .else
    invoke GetProcessWindowStation
    mov edx,eax
    invoke GetUserObjectInformationW,edx,UOI_NAME,addr buf1,63,addr v3
    invoke GetCurrentThreadId
    invoke GetThreadDesktop,eax
    mov edx,eax
    invoke GetUserObjectInformationW,edx,UOI_NAME,addr buf2,63,addr v3
    invoke wsprintfW,addr buf,offset _swd2,addr buf3,v1,addr buf1,addr buf2
  .endif
  invoke WriteStringToFileW,addr buf,addr app_txt,2

  invoke WriteStringToFileW,offset _wnd_head,addr app_txt,2
  invoke WriteEnumIsWindowToFileW_,addr app_txt,esi
  ret
Main endp

;###########################################################################

start:
  invoke Main
  invoke ExitProcess,0
end start

;###########################################################################
